import * as server from '@minecraft/server'
import * as ui from '@minecraft/server-ui'
import { Player, world, system } from "@minecraft/server";

const test = new ui.ModalFormData().title('§d§lTuff Golems Nick Command');
test.textField("Select a Nickname", "Name");
test.toggle("Nick Enabled", true);

const test2 = new ui.ActionFormData()
test2.body('Select any Hive rank. If you dont want a rank select No Rank.')
test2.title("§f§lSelect a Rank")
test2.button("§8[§eHive§8]")
test2.button("§8[§3Helper§8]")
test2.button("§8[§dVIP§8]")
test2.button("§8[§cYT§8]")
test2.button("§8[§dStreamer§8]")
test2.button("§8[§dTikTok§8]")
test2.button("§8[§a+§8]")
test2.button("§cNo Rank")


const test3 = new ui.ActionFormData()
test3.body('Select if you want a hub title.')
test3.title("§d§lHub Title")
test3.button("§cNo Hub Title")
test3.button("§aHub Title")

const test4 = new ui.ModalFormData().title('§d§lHub Title');
test4.textField("Select a Hub Title", "Hub Title")




async function page1(player) {
    const result = await test.show(player)
    const selection = result.selection
    if (result.canceled) return;
    let [textField, toggle] = result.formValues;
    player.nameTag = (textField)
    page2(player)

    if ((toggle) == false) {
        player.nameTag = player.name

    }
    else (
        player.nameTag = (textField)
    )

}
async function page2(player) {
    const result = await test2.show(player)
    const selection = result.selection
    if (selection == 0) {
        player.nameTag = (`§e${player.nameTag} §8[§eHive§8]`)
        page3(player)
    }
    if (selection == 1) {
        player.nameTag = (`§3${player.nameTag} §8[§3Helper§8]`)
        page3(player)
    }
    if (selection == 2) {
        player.nameTag = (`§d${player.nameTag} §8[§dVIP§8]`)
        page3(player)
    }
    if (selection == 3) {
        player.nameTag = (`§c${player.nameTag} §8[§cYT§8]`)
        page3(player)
    }
    if (selection == 4) {
        player.nameTag = (`§d${player.nameTag} §8[§dStreamer§8]`)
        page3(player)
    }
    if (selection == 5) {
        player.nameTag = (`§d${player.nameTag} §8[§dTikTok§8]`)
        page3(player)
    }
    if (selection == 6) {
        player.nameTag = (`§a${player.nameTag} §8[§a+§8]`)
        page3(player)
    }
    if (selection == 7) {
        page3(player)
    }
}

async function page3(player) {
    const result = await test3.show(player)
    const selection = result.selection
    if (selection == 0) {
        return;
    }
    if (selection == 1) {
        page4(player)
    }
}

async function page4(player) {
    const result = await test4.show(player)
    if (result.canceled) return;
    let [textField] = result.formValues;
    player.nameTag = (`${player.nameTag}\n${textField}`)

}

//ITEM FORMS
world.afterEvents.itemUse.subscribe(eventData => {
    const entity = eventData.source;
    const item = eventData.itemStack;
    if (item.typeId !== "tuff:namechanger")
        return;
    page1(entity)

})


world.beforeEvents.chatSend.subscribe((ce) => {
    const msg = ce.message
    const player = ce.sender
    const args = msg.replace("-nick", "").replace(" ", "").replace("^", "\n")

    world.sendMessage(`${player.nameTag} §r§l§7»§r ${msg}`);
    ce.cancel = true;
    if (msg.startsWith(`-nick`)) {
        ce.cancel = true
        system.run(() => {
            player.nameTag = `${args}`
            player.sendMessage(`§aChanged Name to: §r${args}`)
        })
    }
})

